/**
 Copyright Souke (2018)

 contact@souke.fr

 Ce logiciel est un programme informatique servant à aider les producteurs
 à distribuer leur production en circuits courts.

 Ce logiciel est régi par la licence CeCILL soumise au droit français et
 respectant les principes de diffusion des logiciels libres. Vous pouvez
 utiliser, modifier et/ou redistribuer ce programme sous les conditions
 de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA
 sur le site "http://www.cecill.info".

 En contrepartie de l'accessibilité au code source et des droits de copie,
 de modification et de redistribution accordés par cette licence, il n'est
 offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
 seule une responsabilité restreinte pèse sur l'auteur du programme,  le
 titulaire des droits patrimoniaux et les concédants successifs.

 A cet égard  l'attention de l'utilisateur est attirée sur les risques
 associés au chargement,  à l'utilisation,  à la modification et/ou au
 développement et à la reproduction du logiciel par l'utilisateur étant
 donné sa spécificité de logiciel libre, qui peut le rendre complexe à
 manipuler et qui le réserve donc à des développeurs et des professionnels
 avertis possédant  des  connaissances  informatiques approfondies.  Les
 utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
 logiciel à leurs besoins dans des conditions permettant d'assurer la
 sécurité de leurs systèmes et ou de leurs données et, plus généralement,
 à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.

 Le fait que vous puissiez accéder à cet en-tête signifie que vous avez
 pris connaissance de la licence CeCILL, et que vous en avez accepté les
 termes.
 */

$(document).ready(function () {
    opendistrib_home_text_animation();
    opendistrib_signup();
    producersModule.init();
    aboutProducersTestimonialsCarousel.init();
});

function opendistrib_home_text_animation() {
    var
        words = [
            '<i class="bi bi-eye"></i> présenter votre activité',
            '<i class="bi bi-calendar-check"></i> gérer vos prises de commandes',
            '<i class="bi bi-download"></i> télécharger vos récapitulatifs de commande',
            '<i class="bi bi-send"></i> communiquer avec vos clients',
            '<i class="bi bi-file-earmark-text"></i> générer vos bons de livraisons et factures',
            '<i class="bi bi-currency-euro"></i> comptabiliser les paiements',
            '<i class="bi bi-graph-up"></i> obtenir des statistiques de vente'
        ],
        part,
        i = 0,
        offset = 0,
        len = words.length,
        forwards = true,
        skip_count = 0,
        skip_delay = 10,
        speed = 3000;

    var wordflick = function(){
        part = words[i];
        $('.site-iamproducer .word-animate span').html(part);
        setInterval(function(){
            i ++;
            if(i >= len){
                i=0;
            }
            part = words[i];
            $('.site-iamproducer .word-animate span').hide().html(part).fadeIn();
        }, speed);
    };

    $(document).ready(function(){
        wordflick();
    });
}

var UrlManager = {
    getBaseUrl: function () {
        return $('meta[name=baseurl]').attr('content') + '/';

    },
    getBaseUrlAbsolute: function () {
        return $('meta[name=baseurl-absolute]').attr('content') + '/';
    }
};

var aboutProducersTestimonialsCarousel = {
    getBlock: function(childElementSelector) {
        var selector = '#carousel-producers-testimonials';
        if(childElementSelector) {
            return $(selector).find(childElementSelector);
        }

        return $(selector);
    },
    init: function() {
        var app = this;
        $block = app.getBlock();
        var selector = 'carousel-producers-testimonials';

        // init carousel
        var carousel = document.getElementById(selector);
        if(carousel) {
            new bootstrap.Carousel("#"+selector);
            app.eventSlide();
            carousel = document.getElementById(selector);
            carousel.addEventListener('slid.bs.carousel', function() {
                app.eventSlide();
            });
        }
    },
    eventSlide: function() {
        var heightCurrentItem = this.getBlock('.carousel-item.active .carousel-caption-inner').height() + 50;

        this.getBlock().height(heightCurrentItem);
        this.getBlock('.carousel-item.active').height(heightCurrentItem);
        this.getBlock('.carousel-item.active .carousel-caption').height(heightCurrentItem);
    }
};

var producersModule = {
    map: null,
    mapMarkers: [],
    init: function() {
        this.initMap();
        this.initEventViewProducer();
        this.initMapPositionFixed();
        this.initSearch();
    },
    initMap: function() {
        var app = this;
        if($('#producers-map').length > 0) {
            app.map = L.map('producers-map').setView([46.5471789, 2.534168], 6);

            /* Tiles :
               - Classique : https://tile.openstreetmap.org/{z}/{x}/{y}.png
               - Humanitarian : https://{s}.tile.openstreetmap.fr/hot/{z}/{x}/{y}.png
             */

            L.tileLayer('https://{s}.tile.openstreetmap.fr/hot/{z}/{x}/{y}.png', {
                maxZoom: 19,
                attribution: '© OpenStreetMap'
            }).addTo(app.map);

            $.get(UrlManager.getBaseUrl() + 'site/ajax-producers', {}, function(producers) {
                for(var i = 0; i < producers.length ; i++) {
                    if(producers[i].latitude && producers[i].longitude) {
                        app.mapMarkers[producers[i].id] = L.marker([producers[i].latitude, producers[i].longitude])
                            .bindPopup('<div class="popup-producer"><div class="name">'+producers[i].name+'</div><div class="type">'+producers[i].type+'</div><div class="address"><span class="glyphicon glyphicon-map-marker"></span>'+producers[i].address+'</div><div class="link"><a href="'+producers[i].link+'" class="btn btn-primary btn-sm"><i class="bi bi-shop"></i> Visiter</a></div></div>')
                            .addTo(app.map);
                    }
                }
            });
        }
    },
    initEventViewProducer: function() {
        var app = this;
        $('#producers-list .view-producer').click(function() {
            app.viewProducer($(this).data('id'));
            return false;
        });
    },
    viewProducer: function(idProducer) {
        var app = this;
        if(app.mapMarkers[idProducer]) {
            var marker = app.mapMarkers[idProducer];
            var latLngs = [marker.getLatLng()];
            var markerBounds = L.latLngBounds(latLngs);
            app.map.fitBounds(markerBounds, {maxZoom: 9});
            marker.openPopup();
        }
    },
    initMapPositionFixed: function() {

        var $map = $('#producers-map');
        if($map.length > 0) {
            var $wrapperProducerMap = $('#wrapper-producers-map');

            $map.width($wrapperProducerMap.width());
            $map.height($(window).height() - 150);

            $(window).resize(function(){
                $map.width($wrapperProducerMap.width());
                $map.height($(window).height() - 150);
            });

            $(window).scroll(function(){
                if($(window).width() > 768) {
                    var wrapperProducersMapOffsetTop = $wrapperProducerMap.offset().top;
                    var currentScrollTop = $(this).scrollTop();

                    if(currentScrollTop >= wrapperProducersMapOffsetTop) {
                        if(!$map.hasClass('fixed')) {
                            $map.addClass('fixed');
                        }
                    }
                    else {
                        if($map.hasClass('fixed')) {
                            $map.removeClass('fixed');
                        }
                    }
                }
            });
        }
    },
    initSearch: function() {
        $('#producer-search input').keyup(function() {
            var $alertNoResults = $('.alert-no-results');
            var searchWords = $(this).val().toLowerCase();
            var count = 0;

            if(searchWords && searchWords.length > 0) {
                $('.panel-producer').each(function() {
                    if($(this).find('h2').text().toLowerCase().indexOf(searchWords) >= 0
                        || $(this).find('.location').text().toLowerCase().indexOf(searchWords) >= 0) {

                        $(this).show();
                        count ++;
                    }
                    else {
                        $(this).hide();
                    }
                });

                if(count) {
                    $alertNoResults.hide();
                }
                else {
                    $alertNoResults.show();
                }
            }
            else {
                $alertNoResults.hide();
                $('.panel-producer').show();
            }
        });
    }
};

function opendistrib_signup() {
    if ($('#form-signup').size()) {
        opendistrib_signup_fields_producer();
        $('#option-user, #option-producer').change(function () {
            opendistrib_signup_fields_producer();
        });

        opendistrib_signup_code_producer();
        opendistrib_signup_newsletter();
        $('#signupform-id_producer').change(function () {
            opendistrib_signup_code_producer();
            opendistrib_signup_newsletter();
        });

        // modals
        $('.btn-modal-cgv').click(function() {
            $('#modal-cgv').modal();
            return false;
        });
        $('.btn-modal-prices').click(function() {
            $('#modal-prices').modal();
            return false;
        });
    }
}

function opendistrib_signup_fields_producer() {
    $('#user-producer label').removeClass('active');
    if ($('#option-producer').prop('checked')) {
        $('#fields-producer').show();
        $('#fields-user').hide();
        $('#user-producer label.label-producer').addClass('active');
    } else {
        $('#fields-producer').hide();
        $('#fields-user').show();
        $('#user-producer label.label-user').addClass('active');
    }
}

function opendistrib_signup_code_producer() {
    if ($('#signupform-id_producer  option:selected').hasClass('lock')) {
        $('#bloc-code-acces').fadeIn();
    } else {
        $('#bloc-code-acces').hide();
    }
}

function opendistrib_signup_newsletter() {
    if($('#signupform-id_producer').length) {
        var $fieldNewsletter = $('.field-signupform-newsletter');
        if($('#signupform-id_producer').val()) {
            $fieldNewsletter.show();
        }
        else {
            $fieldNewsletter.hide();
        }
    }
}


